#!/bin/sh
# MartiniB #

PSWFILE="/var/script/reload_emu_names.txt"

# updates:
# 2007.07.06 - uptime limit as second optional parameter
# 2007.05.15 - command 'reboot' changed to '/cgi-bin/admin?command=reboot'
# 2007.05.13 - waiting for RecordingMode=OFF
###
###
if [ "$1" = "now" ] || [ 9"$1" -ge "90000" -a 9"$1" -le "92359" ]; then
	echo OK>/dev/null
else
	echo "!!! wrong parameter !!!"
	echo ""
	echo "Usage: $0 now"
	echo "   or: $0 HourMinute (0000 to 2359)"
	exit 1
fi

if [ ! "$2" ]; then
	UptimeSecLimit="0"
else
	case "$2" in
		*s|*S) I="1";;
		*m|*M) I="60";;
		*h|*H) I="3600";;
		*d|*D) I="86400";;
		*w|*W) I="604800";;
		*) I="0";;
	esac
	if [ "$I" -ne "0" ]; then
		len2=`expr length $2`
		in2=`expr substr "$2" 1 $((len2-1))`
	else
		in2="$2" I="1"
	fi
	if [ "$in2" -ge "0" -a  "$in2" -le "999999"  ]; then
		UptimeSecLimit=$((in2 * I -300))
	else
		echo "!!! wrong second parameter ($2) !!!"
		echo ""
		echo "It must be numeric with optional symbol at the end:"
		echo "s(seconds); m(minutes); h(hours); d(days); w(weeks)"
		exit 1
	fi
fi

foo="$0"
crntNamePath=${foo%.*}
crntNameExt=${foo##*/}
crntNameShort=${crntNameExt%.*}
crntNameTxt="$crntNamePath".txt
TMPFILE=/tmp/"$crntNameShort".tmpWebIF

ConfigPATH="/var/tuxbox/config/enigma/config"
if [ ! -f "$ConfigPATH" ]; then
	ConfigPATH="/etc/enigma/config"
	if [ ! -f "$ConfigPATH" ]; then PortDec="80"; fi
fi
if [ ! $PortDec ]; then
	PortHex=`grep 'webifport=' "$ConfigPATH"| sed -e 's/.*webifport=//'`
	if [ ! $PortHex ]; then
		PortDec="80"
	else
		PortDec=$((0x$PortHex))
	fi
fi

DOCMD="wget -O $TMPFILE -q http://root:"
DOCMD0="@localhost:$PortDec"
DOCMD1="$DOCMD0/cgi-bin"
DOCMD2=$DOCMD1/rc

if [ ! -e "$PSWFILE" ];then
	LOCALPW="dreambox"
	echo "$LOCALPW">"$PSWFILE"
else
	LOCALPW=`cat -u "$PSWFILE"| head -1`
fi

check_box_status (){
	RecIsON=1
	while [ "$RecIsON" = "1" ]
	do
		$DOCMD$LOCALPW$DOCMD0/xml/boxstatus
		RecIsON=`grep "<recording>" $TMPFILE| sed -e 's/.*<recording>//'| sed -e 's/<.*//'`
		if [ "$RecIsON" = "1" ]; then
			sleep 60
		else
			StandbyIsON=`grep "<standby>" $TMPFILE| sed -e 's/.*<standby>//'| sed -e 's/<.*//'`
			if [ "$StandbyIsON" = "1" ]; then echo "StandbyIsON">"$crntNameTxt"; fi
		fi
	done
}

if [ -f "$crntNameTxt" ]; then
	sleep 30
	$DOCMD$LOCALPW$DOCMD1/admin?command=standby
	rm -rf "$crntNameTxt"
fi

while true
do
	DateSTR=`date +%H%M%S`
	if [ "$1" = "now" ] || [ "$DateSTR" -ge "$1"00 -a "$DateSTR" -le "$1"15 ]; then
		Uptime=`cat /proc/uptime| awk {'print $1'}`
		Uptime=${Uptime%.*}
		if [ ! "$1" = "now" ] && [ "$UptimeSecLimit" -ge "$Uptime" ]; then
			#echo wait for uptime limit
			sleep 10
		else
			echo "it's time to reboot"
			check_box_status
			#reboot
			$DOCMD$LOCALPW$DOCMD1/admin?command=reboot
			exit 0
		fi
	else
		sleep 10
	fi
done
